package turing.bomb.GUI;

import java.awt.Color;
import javax.swing.JOptionPane;

/**
 *
 * @author Luzian
 */
public class JTuringBomb extends javax.swing.JFrame {

    private final Color backgroundcolor = new Color(139, 69, 19);
    private final Color buttoncolor = new Color(255, 241, 161);

    /**
     *
     */
    public JTuringBomb() {
        initComponents();
        this.getContentPane().setBackground(Color.black);
        contentPanel.setBackground(backgroundcolor);
        startButton.setBackground(buttoncolor);
        turnOffButton.setBackground(buttoncolor);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSeparator1 = new javax.swing.JSeparator();
        contentPanel = new javax.swing.JPanel();
        customRadioButton2 = new javax.swing.JRadioButton();
        wholeKeySpaceRadioButton3 = new javax.swing.JRadioButton();
        startButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        originalRadioButton1 = new javax.swing.JRadioButton();
        turnOffButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Turing Bomb - by Luzian Bieri");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setForeground(java.awt.Color.lightGray);
        setLocation(new java.awt.Point(0, 0));
        setName("frame2"); // NOI18N
        setResizable(false);

        contentPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        contentPanel.setDoubleBuffered(false);
        contentPanel.setPreferredSize(new java.awt.Dimension(800, 700));

        customRadioButton2.setText("Customizable Turing Bomb");
        customRadioButton2.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        customRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                customRadioButton2ActionPerformed(evt);
            }
        });

        wholeKeySpaceRadioButton3.setText("Exhaust whole key space");
        wholeKeySpaceRadioButton3.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        wholeKeySpaceRadioButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                wholeKeySpaceRadioButton3ActionPerformed(evt);
            }
        });

        startButton.setText("Start");
        startButton.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        startButton.setDefaultCapable(false);
        startButton.setFocusable(false);
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        jTextArea.setEditable(false);
        jTextArea.setBackground(new java.awt.Color(255, 241, 161));
        jTextArea.setColumns(20);
        jTextArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea.setRows(5);
        jTextArea.setText("Description:\n-Original Turing Bomb: Simulates the original Bombe\n-Customizable Turing Bomb: Wheelorders can be chosen as desired\n-Exhaust whole key space: Whole key space is exhausted\n");
        jTextArea.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jTextArea.setEnabled(false);
        jTextArea.setRequestFocusEnabled(false);
        jScrollPane1.setViewportView(jTextArea);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        jLabel1.setText("Turing Bomb");

        jLabel2.setText("by Luzian Bieri");

        originalRadioButton1.setSelected(true);
        originalRadioButton1.setText("Original Turing Bomb");
        originalRadioButton1.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        originalRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                originalRadioButton1ActionPerformed(evt);
            }
        });

        turnOffButton.setText("Turn off");
        turnOffButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                turnOffButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout contentPanelLayout = new javax.swing.GroupLayout(contentPanel);
        contentPanel.setLayout(contentPanelLayout);
        contentPanelLayout.setHorizontalGroup(
            contentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(contentPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(contentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addGroup(contentPanelLayout.createSequentialGroup()
                        .addGroup(contentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2)
                            .addComponent(wholeKeySpaceRadioButton3)
                            .addComponent(customRadioButton2)
                            .addComponent(startButton)
                            .addComponent(originalRadioButton1))
                        .addGap(0, 623, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, contentPanelLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(turnOffButton)))
                .addContainerGap())
        );
        contentPanelLayout.setVerticalGroup(
            contentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(contentPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(13, 13, 13)
                .addComponent(originalRadioButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(customRadioButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(wholeKeySpaceRadioButton3)
                .addGap(14, 14, 14)
                .addComponent(startButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 384, Short.MAX_VALUE)
                .addComponent(turnOffButton)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(contentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(contentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );

        contentPanel.getAccessibleContext().setAccessibleName("");
        contentPanel.getAccessibleContext().setAccessibleDescription("");

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void originalRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_originalRadioButton1ActionPerformed
        customRadioButton2.setSelected(false);
        wholeKeySpaceRadioButton3.setSelected(false);
    }//GEN-LAST:event_originalRadioButton1ActionPerformed

    private void customRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_customRadioButton2ActionPerformed
        originalRadioButton1.setSelected(false);
        wholeKeySpaceRadioButton3.setSelected(false);
    }//GEN-LAST:event_customRadioButton2ActionPerformed

    private void wholeKeySpaceRadioButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_wholeKeySpaceRadioButton3ActionPerformed
        originalRadioButton1.setSelected(false);
        customRadioButton2.setSelected(false);
    }//GEN-LAST:event_wholeKeySpaceRadioButton3ActionPerformed

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        if (originalRadioButton1.isSelected()) {
            Original o = new Original(this);
            o.setVisible(true);
            this.setVisible(false);
        } else if (customRadioButton2.isSelected()) {
            Customizable c = new Customizable(this);
            c.setVisible(true);
            this.setVisible(false);
        } else if (wholeKeySpaceRadioButton3.isSelected()) {
            WholeExhaustion we = new WholeExhaustion(this);
            we.setVisible(true);
            this.setVisible(false);
        } else {
            JOptionPane.showMessageDialog(this, "Please chose one element!", "No element chosen", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_startButtonActionPerformed

    private void turnOffButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_turnOffButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_turnOffButtonActionPerformed

    /**
     *
     * @param args
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JTuringBomb.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JTuringBomb.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JTuringBomb.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JTuringBomb.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new JTuringBomb().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel contentPanel;
    private javax.swing.JRadioButton customRadioButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextArea jTextArea;
    private javax.swing.JRadioButton originalRadioButton1;
    private javax.swing.JButton startButton;
    private javax.swing.JButton turnOffButton;
    private javax.swing.JRadioButton wholeKeySpaceRadioButton3;
    // End of variables declaration//GEN-END:variables
}
